package com.storlead.user.util;

import com.storlead.user.pojo.entity.DeptEntity;
import com.storlead.user.model.DepartIdModel;
import com.storlead.user.model.DeptTreeModel;

import java.util.ArrayList;
import java.util.List;

/**
 * <P>
 * 对应部门的表,处理并查找树级数据
 * <P>
 *
 * @Author: Steve
 * @Date: 2019-01-22
 */
public class FindsDepartsChildrenUtil {

	//部门树信息-树结构
	//private static List<SysDepartTreeModel> sysDepartTreeList = new ArrayList<SysDepartTreeModel>();

	//部门树id-树结构
    //private static List<DepartIdModel> idList = new ArrayList<>();

    /**
     * queryTreeList的子方法 ====1=====
     * 该方法是s将SysDepart类型的list集合转换成SysDepartTreeModel类型的集合
     */
    public static List<DeptTreeModel> wrapTreeDataToTreeList(List<DeptEntity> recordList) {
        // 在该方法每请求一次,都要对全局list集合进行一次清理
        //idList.clear();
    	List<DepartIdModel> idList = new ArrayList<DepartIdModel>();
        List<DeptTreeModel> records = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            DeptEntity depart = recordList.get(i);
            records.add(new DeptTreeModel(depart));
        }
        List<DeptTreeModel> tree = findChildren(records, idList);
        setEmptyChildrenAsNull(tree);
        return tree;
    }

    /**
     * 获取 DepartIdModel
     * @param recordList
     * @return
     */
    public static List<DepartIdModel> wrapTreeDataToDepartIdTreeList(List<DeptEntity> recordList) {
        // 在该方法每请求一次,都要对全局list集合进行一次清理
        //idList.clear();
        List<DepartIdModel> idList = new ArrayList<DepartIdModel>();
        List<DeptTreeModel> records = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            DeptEntity depart = recordList.get(i);
            records.add(new DeptTreeModel(depart));
        }
        findChildren(records, idList);
        return idList;
    }

    /**
     * queryTreeList的子方法 ====2=====
     * 该方法是找到并封装顶级父类的节点到TreeList集合
     */
    private static List<DeptTreeModel> findChildren(List<DeptTreeModel> recordList,
                                                    List<DepartIdModel> departIdList) {

        List<DeptTreeModel> treeList = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            DeptTreeModel branch = recordList.get(i);
//            if ("0".equals(branch.getPid())) {
            if (branch.getPid()==0) {
                treeList.add(branch);
                DepartIdModel departIdModel = new DepartIdModel().convert(branch);
                departIdList.add(departIdModel);
            }
        }
        getGrandChildren(treeList,recordList,departIdList);

        //idList = departIdList;
        return treeList;
    }

    /**
     * queryTreeList的子方法====3====
     *该方法是找到顶级父类下的所有子节点集合并封装到TreeList集合
     */
    private static void getGrandChildren(List<DeptTreeModel> treeList, List<DeptTreeModel> recordList, List<DepartIdModel> idList) {

        for (int i = 0; i < treeList.size(); i++) {
            DeptTreeModel model = treeList.get(i);
            DepartIdModel idModel = idList.get(i);
            for (int i1 = 0; i1 < recordList.size(); i1++) {
                DeptTreeModel m = recordList.get(i1);
                if (m.getPid()!=null && m.getPid().equals(model.getId())) {
                    model.getChildren().add(m);
                    DepartIdModel dim = new DepartIdModel().convert(m);
                    idModel.getChildren().add(dim);
                }
            }
            getGrandChildren(treeList.get(i).getChildren(), recordList, idList.get(i).getChildren());
        }

    }


    /**
     * queryTreeList的子方法 ====4====
     * 该方法是将子节点为空的List集合设置为Null值
     */
    private static void setEmptyChildrenAsNull(List<DeptTreeModel> treeList) {

        for (int i = 0; i < treeList.size(); i++) {
            DeptTreeModel model = treeList.get(i);
            if (model.getChildren().size() == 0) {
                model.setChildren(null);
                model.setIsLeaf(true);
            }else{
                setEmptyChildrenAsNull(model.getChildren());
                model.setIsLeaf(false);
            }
        }
        // sysDepartTreeList = treeList;
    }
}
